import torch
from time import time


class EarlyStop:

    def __init__(self, patience=20, lower_is_better=False):
        self.patience_limit = patience
        self.patience = patience
        self.best_score = None
        self.best_epoch = None
        self.better_than = lambda a,b: a<b if lower_is_better else a>b
        self.STOP = False
        self.IMPROVED = False

    def __call__(self, watch_score, epoch):
        if self.best_score is None or self.better_than(watch_score, self.best_score):
            self.IMPROVED = True
            self.best_score = watch_score
            self.best_epoch = epoch
            self.patience = self.patience_limit
        else:
            self.IMPROVED = False
            self.patience -= 1
            if self.patience <= 0:
                self.STOP = True

